local class = require "yale/class"
local U = require "yale/util"
local SM = require "yale/soundmanager"

local setColor = love.graphics.setColor
local polygon = love.graphics.polygon
local newSoundData = love.sound.newSoundData
local function play(sd)
	soundmanager:play(sd)
end

local EN = require "yale/entity"
local Ex = require "explosion"

local sin = memsin
local cos = memcos


sfx_hit		= newSoundData("rsc/sfx/bullet_hit.wav")
--sfx_miss	= newSoundData("rsc/sfx/bullet_miss.wav")

class "bullet" ("entity") {}

local function init_physics(b)
	local body = b:add_body("main", 0, 0)
	local shape = b:add_shape("main", "rectangle", "main", 0, 0, 10, 2, b.angle)
	shape:setCategory(b.cat) -- set category
	shape:setMask(3, 4) -- mask bullets categories
	body:setMassFromShapes()
	body:setBullet(true)
	body:applyImpulse(b.I*cos(b.angle), b.I*sin(b.angle))
	b.body = body
	b.shape = shape
end

local function update(b, dt)
	if b.body:isFrozen() then b.dead = true end
end

local function draw(b)
	setColor(unpack(b.fcolor))
	polygon("fill", b.shape:getPoints())
	setColor(255, 255, 255)
	polygon("line", b.shape:getPoints())
end

local function collision_add(b, e, c, switch)
	local df = e and e.damage or nil
	if df then
		-- damage the fuckerr
		df(e, b.dam)
		
		play(sfx_hit)
	--else
	--	play(sfx_miss)
	end
	b.body:setPosition(-10000, -10000)
	b.dead = true
	local x, y = c:getPosition()
	-- explosion
	Ex{ world = b.world, x = x, y = y, speed = 100*b.dam }
end

local B = class.bullet
B.init_physics = init_physics
B.update = update
B.draw = draw
B.collision_add = collision_add
return B
