local class = require "yale/class"
local U = require "yale/util"

local circle = love.graphics.circle
local setColor = love.graphics.setColor

local EN = require "yale/entity"

class "explosion" ("entity") {
	init = function(o)
		EN.init(o)
		o.mlife = .25
		o.speed = o.speed or 30
		o.radius = 0
		o.life = 0
		o.hue = .15
		o.ratio = 0
	end
}

local function init_physics(e)
end

local function update(e, dt)
	local life = e.life + dt
	e.life = life
	local mlife = e.mlife
	
	if life > mlife then
		e.dead = true
		return
	end
	
	e.hue = .15*(mlife - life)
	e.radius = life*e.speed
	e.ratio = life / mlife
end

local function draw(e)
	setColor(U.hsl2rgb(e.hue, .8, .6+.2*e.ratio, 256 - e.ratio * 256))
	circle("line", e.x, e.y, e.radius, 32)
end

local E = class.explosion
E.init_physics = init_physics
E.update = update
E.draw = draw
return E
