-- lodex
-- schmup
-- by cag

local U = require "yale/util"
require "soundmanager"
memsin = U.memoize(math.sin)
memcos = U.memoize(math.cos)

local W = require "yale/world"
local Wa = require "walls"
local P = require "player"
local BE = require "enemies/basic"
local BU = require "enemies/bulldog"
local GE = require "enemies/gunner"
local HG = require "enemies/homing"

--
function love.run()
    if love.load then love.load(arg) end
    local dt = 0
	local fT = 1/60 -- frame cap
    -- Main loop time.
    while true do
        --if love.timer then
            love.timer.step()
            dt = dt + love.timer.getDelta()
        --end
        --if love.update then
			while dt > 0 do
				love.update(fT)
				dt = dt - fT
			end
		--end -- will pass 0 if love.timer is disabled
        --if love.graphics then
            love.graphics.clear()
            --if love.draw then
				love.draw()
			--end
        --end
        -- Process events.
        --if love.event then
            for e,a,b,c in love.event.poll() do
                if e == "q" then
                    --if love.audio then
                        love.audio.stop()
                    --end
                    return
                end
                love.handlers[e](a,b,c)
            end
        --end
        --if love.graphics then
			love.graphics.present()
		--end
        --if love.timer then
			love.timer.sleep(1)
		--end
    end
end
--]]

function love.load()
	world = W{ px_per_m=16 }
	Wa{ world = world }
	player = P{ world = world, x = 256, y = 240 }
	--		BE{ world = world, x = 512+256, y = 240 }
	--
	for i = 1024, 1536, 64 do
		for j = 40, 460, 80 do
		--	BE{ world = world, x = i, y = j }
		end
		for j = 20, 460, 80 do
		--	BU{ world = world, x = i, y = j }
		end
		for j = 60, 460, 80 do
		--	HG{ world = world, x = i, y = j }
		end
		for j = 0, 460, 80 do
			GE{ world = world, x = i, y = j }
		end
	end
	--]]
	--E{ world = world, x = 420, y = 160 }
	--E{ world = world, x = 420, y = 200 }
	--E{ world = world, x = 420, y = 280 }
	--E{ world = world, x = 420, y = 320 }
	huey = 0
end

function love.update(dt)
	huey = (huey+dt)%10
	soundmanager:update(dt)
	world:update(dt)
end

function love.draw()
	love.graphics.setBackgroundColor(U.hsl2rgb(huey*.1, 1, .05))
	world:draw()
end
