local class = require "yale/class"

local getScreenWidth = love.graphics.getWidth
local getScreenHeight = love.graphics.getHeight
local newBody = love.physics.newBody
local newRectangleShape = love.physics.newRectangleShape

local EN = require "yale/entity"

-- walls for screen
-- lolol

class "walls" ("entity") {
	init = function(o)
		EN.init(o)
		o.invisible = true
		o.paused = true -- doesn't update, this.
	end
}

local function init_physics(o)
	local world = o.world
	local wt = o.wall_thickness or world.px_per_m*.1
	local w = getScreenWidth()
	local h = getScreenHeight()
	local physics = world.physics
	local walls = {}
	-- left and right walls
	walls.left = newBody(physics, 0, h/2)
	walls.lshape = newRectangleShape(walls.left, 0, 0, wt, h)
	walls.lshape:setCategory(16)
	walls.right = newBody(physics, w, h/2)
	walls.rshape = newRectangleShape(walls.right, 0, 0, wt, h)
	walls.rshape:setCategory(16)
	-- up and down
	walls.up = newBody(physics, w/2, 0)
	walls.ushape = newRectangleShape(walls.up, 0, 0, w, wt)
	walls.ushape:setCategory(16)
	walls.down = newBody(physics, w/2, h)
	walls.dshape = newRectangleShape(walls.down, 0, 0, w, wt)
	walls.dshape:setCategory(16)
	
	o.walls = walls
end

local W = class.walls
W.init_physics = init_physics
return W
