local assert = assert
local setmetatable = setmetatable
local type = type

local U = require "yale/util"

-- yale's class implementation
-- environment
local C = {}
local mt = {}
setmetatable(C, mt)

-- stuff
local function make_class(name, parent, class)
	assert(type(name) == "string", ("class name must be type `string'; got type `%s' instead"):format(type(name)))
	assert(not parent or type(parent) == "string", ("class `%s' has invalid parent class"):format(name))
	assert(type(class) == "table", ("class `%s' must have a table description"):format(name))
	local pc = C[parent and parent or nil]
	if parent then assert(pc, ("class `%s' has undeclared parent class `%s'"):format(name, parent)) end
	
	C[name] = class
	local cmt = {
		__index = pc,
		__call = function(c, o)
			local o = o or {}
			local init = c.init
			setmetatable(o, c)
			if init then init(o) end
			return o
		end
	}
	setmetatable(class, cmt)
	class.__index = class
	class.type = name
	class.is_a = function(o, t)
		if o.type == t then return true end
		local p = o.parent
		return p and p:is_a(t) or false
	end
	
	return class
end

-- metastuff
function mt.__call(ct, name)
	return U.curry(make_class, 3)(name)
end

-- fin
C.make_class = make_class
return C
