--[[
 Copyright (c) 2010 bartbes

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 
 -- modified a bit to reflect yale api
 -- why write new solutions when there are good viable ones readily available?
      ~cag

 -- currently broken
 -- will either fix or scrap and just use bartbes'
--]]

local newSource = love.audio.newSource
local play = love.audio.play
local stop = love.audio.stop

local remove = table.remove

local queue = {}
local playlist = {}
local currentsong = -1

--do the magic
local function play(sndData)
	--make a source out of the sound data
	local src = newSource(sndData, "static")
	--add to queue
	queue[#queue+1] = src
	--and play it
	play(src)
end

--do the music magic
local function playMusic(first, ...)
	--stop all currently playing music
	for i=1,#playlist do
		local v = playlist[i]
		stop(v)
	end
	--decide if we were passed a table or a vararg,
	--and assemble the playlist
	if type(first) == "table" then
		playlist = first
	else
		playlist = {first, ...}
	end
	currentsong = 1
	--play
	play(playlist[1])
end

--update
local function update(dt)
	--check which sounds in the queue have finished, and remove them
	local removelist = {}
	for i=1,#queue do
		local v = queue[i]
		if v:isStopped() then
			removelist[#removelist+1] = i
		end
	end
	--we can't remove them in the loop, so use another loop
	for i=1,#removelist do
		local v = removelist[i]
		remove(queue, v-i+1)
	end
	--advance the playlist if necessary
	if currentsong ~= -1 and playlist and playlist[currentsong]:isStopped() then
		currentsong = currentsong + 1
		if currentsong > #playlist then
			currentsong = 1
		end
		play(playlist[currentsong])
	end
end

local soundmanager = {}
soundmanager.play = play
soundmanager.playMusic = playMusic
soundmanager.update = update
return soundmanager